package viva

import (
	"github.com/google/uuid"
	"payment-poc/state"
	"time"
)

const VivaUrl = "https://demo-api.vivapayments.com"

type VivaDb struct {
	Id            uuid.UUID `db:"id"`
	OrderId       string    `db:"order_id"`
	TransactionId uuid.UUID `db:"transaction_id"`
	TotalAmount   int64     `db:"total_amount"`
	Lang          string    `db:"lang"`

	EventId string `db:"event_id"`
	ECI     string `db:"eci"`

	DateTime time.Time `db:"date_time"`

	// transaction response

	State state.PaymentState `db:"payment_state"`
}
